#include "IControllerBase.h"

IControllerBase::IControllerBase(QObject *parent) :
    QObject(parent),
    _hasFocus(false),
    _handleFocus(true),
    _quickView(nullptr),
    _window(nullptr)
{
}

IControllerBase::~IControllerBase()
{
    if (_quickView)
        delete _quickView;
}

QQuickView* IControllerBase::quickView()
{
    return _quickView;
}

void IControllerBase::setQuickView(QQuickView *quickView)
{
    _quickView = quickView;
}

bool IControllerBase::handleFocus()
{
    return _handleFocus;
}

void IControllerBase::setHandleFocus(bool handleFocus)
{
    _handleFocus = handleFocus;
}

void IControllerBase::editorReady()
{

}

void IControllerBase::grabFocus()
{
    if (_quickView && !_hasFocus && _handleFocus)
    {
        _hasFocus = true;

        _quickView->setFlags(Qt::Tool | Qt::FramelessWindowHint);
        _quickView->requestActivate();
    }
}

void IControllerBase::releaseFocus()
{
    if (_quickView && _hasFocus && _handleFocus)
    {
        _hasFocus = false;

        _quickView->setFlags(Qt::Tool | Qt::FramelessWindowHint | Qt::WindowDoesNotAcceptFocus);
    }
}
