#ifndef ICONTROLLERBASE_H
#define ICONTROLLERBASE_H

#include "IControllerBase.h"

#include <QObject>
#include <QKeyEvent>
#include <QWindow>
#include <QQuickView>
#include <QRect>

class IControllerBase : public QObject
{
    Q_OBJECT

public:
    explicit IControllerBase(QObject *parent=nullptr);
    ~IControllerBase();

    QQuickView* quickView();
    void setQuickView(QQuickView *quickView);

    bool handleFocus();
    void setHandleFocus(bool handleFocus);

public slots:
    virtual void editorReady();

signals:
    void keyUpPressed();
    void keyDownPressed();
    void updateHostDisplay();

public slots:
    void grabFocus();
    void releaseFocus();

protected:
    bool _hasFocus;
    bool _handleFocus;

    QQuickView* _quickView;
    QWindow* _window;
};

#endif // ICONTROLLERBASE_H
