#include <VDL.h>
#include <Controller.h>

AudioEffect* createEffectInstance(audioMasterCallback audioMaster)
{
    QGuiApplication* app = IVst::app();

    Controller* controller = new Controller(app);

    IVst* vst = new VDL(audioMaster, 0, 0);

    vst->setController(controller);
    vst->setEditorWithDimensions(640,480);

    return vst;
}

VDL::VDL(audioMasterCallback audioMaster, int programs, int parameters) :
    IVst(audioMaster, programs, parameters)
{
    if (audioMaster)
    {
        setNumInputs(0);
        setNumOutputs(2);
        canProcessReplacing();
        setUniqueID(CCONST('V','D','L','-'));
    }
}

VstInt32 VDL::processEvents(VstEvents* ev)
{
    Q_UNUSED(ev)
    return 1;
}

void VDL::processReplacing(float** inputs, float** outputs, VstInt32 frames)
{
    Q_UNUSED(inputs)
    Q_UNUSED(outputs)
    Q_UNUSED(frames)
}

bool VDL::getEffectName(char* name)
{
    vst_strncpy (name, "ConnectionOpen", kVstMaxEffectNameLen);

    return true;
}

bool VDL::getVendorString(char* text)
{
    vst_strncpy (text, "ConnectionOpen Inc.", kVstMaxVendorStrLen);

    return true;
}

bool VDL::getProductString(char* text)
{
    vst_strncpy(text, "ConnectionOpen", kVstMaxProductStrLen);

    return true;
}

VstInt32 VDL::getVendorVersion()
{
    return 0*1000+0*100+1*10;
}

VstInt32 VDL::canDo(const char* feature)
{
    Q_UNUSED(feature)
    return -1;
}
