#ifndef IVSTEDITOR_H
#define IVSTEDITOR_H

#include <QObject>
#include <QWindow>
#include <QQuickView>
#include <QtQml>
#include <QScreen>

#include "aeffeditor.h"

class IVst;
#ifdef USE_CONTROLLER_BASE
class IControllerBase;
#else
class IController;
#endif
class IVstEditor : public QObject, public AEffEditor
{
    Q_OBJECT
public:
    #ifdef USE_CONTROLLER_BASE
    IVstEditor(AudioEffect* effect, IControllerBase *controller);
    #else
    IVstEditor(AudioEffect* effect, IController *controller);
    #endif
    ~IVstEditor();

    bool open(void *ptr);
    void close();

    bool getRect(ERect **rect);

    #ifdef Q_OS_OSX
    static QStringList arguments();
    #endif

    bool onKeyUp(VstKeyCode &keyCode);
    bool onKeyDown(VstKeyCode &keyCode);

    QQuickItem* rootObject();
    QQmlContext* rootContext();

private:
    void push();
    void pop();
    void cleanup();

    #ifdef USE_CONTROLLER_BASE
    IControllerBase* _controller;
    #else
    IController* _controller;
    #endif
    QQuickView* _quickView;

    #ifdef Q_OS_WIN
    QWindow* _window;
    #else
    void* _nswindow;
    #endif

    void* _ptr;

    bool _hasFocus;
};

#endif // IVSTEDITOR_H
